


/**
 * Represents an abstract algorithm on an LRStruct.  Acts as a visitor to a
 * LRStruct host.
 * @author Dung X. Nguyen  Copyright 2001 - All rights reserved.
 * @since 10/09/01
 * @dependency lrs.LRStruct visitor
 */
public class SwapEnds implements IAlgo {

    public static final SwapEnds Singleton = new SwapEnds();

    private SwapEnds(){}

    public Object emptyCase(LRStruct host, Object inp){
	throw new IllegalArgumentException("something went wrong");
    }


    public Object nonEmptyCase(final LRStruct host, Object inp){
	LRStruct taillist = host.getRest();
	
	return taillist.execute(new IAlgo(){
		public Object emptyCase(LRStruct child, Object parent){
		    return null;
		}
		public Object nonEmptyCase(LRStruct child, Object parent){
		    return ((LRStruct) child.getRest()).execute(new IAlgo(){
			    public Object emptyCase(LRStruct child, Object parent){
				Integer lastElement = ((Integer) ((LRStruct) parent).getFirst());
				Integer firstElement = ((Integer) host.getFirst());
				
				host.setFirst(lastElement);
				((LRStruct) parent).setFirst(firstElement);
				return host;
			    }
			    public Object nonEmptyCase(LRStruct child, Object parent){
				return ((LRStruct) child.getRest()).execute(this, child);
			    }
			}, child);
		}
	    }, host);
    }
}


